//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern double RfPeriod  = 25;
extern int    Price     =  PRICE_CLOSE;

double rf[];
double rfda[];
double rfdb[];
double slope[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double c1,c2,c3;
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,rfda); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,rfdb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,rf);
   SetIndexBuffer(3,slope);
      double a1 = MathExp(-1.414*Pi/RfPeriod);
      double b1 = 2.0*a1*MathCos(1.414*Pi/RfPeriod);
             c2 = b1;
             c3 = -a1*a1;
             c1 = 1.0 - c2 - c3;
   
   //
   //
   //
   //
   //
       
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
          
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" roofing filter ("+DoubleToStr(RfPeriod,2)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][2];
#define _price 0
#define _hp    1

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rf[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (timeFrame != Period())
   {
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);               
            rf[i]    = iCustom(NULL,timeFrame,indicatorFileName,"",RfPeriod,Price,2,y);
            slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"",RfPeriod,Price,3,y);
            rfda[i]  = EMPTY_VALUE;
            rfdb[i]  = EMPTY_VALUE;
            if (slope[i] == 1) rfda[i] = 1;
            if (slope[i] ==-1) rfdb[i] = 1;
      }
      return(0);   
   }

   //
   //
   //
   //
   //
   //

   double modif = 2.0*Pi/48.0;
   double alpha = (MathCos(0.707*modif) + MathSin(0.707*modif)-1)/MathCos(0.707*modif);
   if (ArrayRange(work,0)!= Bars) ArrayResize(work,Bars);
   for(i=limit, r =Bars-i-1; i >= 0; i--,r++)
   {
      work[r][_price] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      work[r][_hp]    = (1.0-alpha/2.0)*(1.0-alpha/2.0)*(work[r][_price]-2.0*work[r-1][_price]+work[r-2][_price])+2.0*(1-alpha)*work[r-1][_hp]-(1-alpha)*(1-alpha)*work[r-2][_hp];
                rf[i] = c1*(work[r][_hp]+work[r-1][_hp])/2.0 + c2* rf[i+1] + c3*rf[i+2];
                rfda[i] = EMPTY_VALUE;
                rfdb[i] = EMPTY_VALUE;
                slope[i] = slope[i+1];
                  if (rf[i]>rf[i+1]) slope[i] =  1;
                  if (rf[i]<rf[i+1]) slope[i] = -1;
                  if (slope[i] == 1) rfda[i]  = 1;
                  if (slope[i] ==-1) rfdb[i]  = 1;
   }         
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}